<?php

/**
 * BuddyServ IRC Services
 * 
 * Flood Service Event handler
 * 
 * @name FloodServ
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Clients
 * @version $Id: Class.floodserv.php 361 2009-12-18 06:57:40Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */

class floodserv
{
	static $client;
	static $floodjoins = array();
	static $floodmessage = array();
	static $floodclones = array();
	static $floodnicks = array();
	static $repeats = array();
	static $times = array();

	/**
	 * Attach the serviceclient object to $client
	 * and initialize the current service bot.
	 * 
	 * @param string $nick
	 * @param string $username
	 * @param string $host
	 * @param string $name
	 * @return void
	 */
	static function initialize($nick, $username, $host, $name, $modes)
	{
		global $config;
		
		self::$client = new serviceclient();
		self::$client->initialize($nick, $username, $host, $name, $modes);
		
		$mtimes = explode(':', $config['floodserv']['messagePer']);
		$jtimes = explode(':', $config['floodserv']['joinsPer']);
		$ntimes = explode(':', $config['floodserv']['nicksPer']);
		
		self::$times = array(
			'privmsg'	=> array(
				'time'		=> $mtimes[1],
				'count'		=> $mtimes[0]),
			'joins'		=> array(
				'time'		=> $jtimes[1],
				'count'		=> $jtimes[0]),
			'nicks'		=> array(
				'time'		=> $ntimes[1],
				'count'		=> $ntimes[0]));

	}
	
		/**
		 * Magic getter
		 *
		 * @param string $what
		 * @return mixed
		 */
		function __get($what)
		{
			if (self::$client->{$what})
				return self::$client->{$what};
				
		}
		
		/**
		 * Introduce the client to the uplink server.
		 * 
		 * @return void
		 */
		static function introduce()
		{
			self::$client->introduce();
		}
		
		static function throttleMessages($sender, $target)
		{
			global $config, $irc;
			
			$userObj = user::getuser($sender);
			
			/* If identified, and staff member, they are exempt */
			if (($userObj->identified()) and ($userObj->level > SITE_UPLOADER))
				return;
				
			if (!is_array(self::$floodmessage[$target]))
				self::$floodmessage[$target] = array();
				
			if (array_key_exists($userObj->fullMask(), self::$floodmessage[$target]))
			{
				$timepassed = time() - self::$floodmessage[$target][$userObj->fullMask()]['time'];
				
				if ($timepassed > self::$times['privmsg']['time'])
				{
					self::$floodmessage[$target][$userObj->fullMask()]['count'] = 0;
					self::$floodmessage[$target][$userObj->fullMask()]['time'] = time();
				}
				
				else
				{
					if (++self::$floodmessage[$target][$userObj->fullMask()]['count'] > self::$times['privmsg']['count'])
					{
						/* check if a repeat offender */
						if (array_key_exists($userObj->fullMask(), self::$repeats))
						{
							/* If longer than, say, 15 minutes, ignore the repeat. */
							if ((time() - self::$repeats[$userObj->fullMask()]) > 900)
							{
								self::$repeats[$userObj->fullMask()] = time();
							}
							
							/* gline the user */
							else
							{
								$timespire = ($config['floodserv']['glineTime'] * 60);
								$timespire = time() + $timespire;
								
								if (gline::create($timespire,floodserv::$client->nick, '*@'.$userObj->host, $config['floodserv']['glineReason'].' ['.$target.']'))
									$irc->send(sprintf(OPERWALL, self::$client->nick,
										self::$client->nick.' Added AKill for *@'.$userObj->host.' ('.$config['floodserv']['glineReason'].' in '.$target.')'));
							
								/* now add the kline to the servers */
								$irc->send(sprintf(KLINE, self::$client->nick, $timespire, '*', $userObj->host, $config['floodserv']['glineReason'].' ['.$target.']'));
								self::$client->kill($sender, 'K-Lined: '.$config['floodserv']['glineReason'].' in '.$target);
								return true;
							}
						}
						
						/* not a repeat offender, add to repeats. */
						self::$repeats[$userObj->fullMask()] = time();
						unset(self::$floodmessage[$target][$userObj->fullmask()]);
						self::$client->kill($sender, $config['floodserv']['glineReason'].' ['.$target.'] '. self::$times['privmsg']['count'].' in '.self::$times['privmsg']['time'].' seconds.');
						return true;
					}
				}
			}
			
			self::$floodmessage[$target][$userObj->fullMask()]['time'] = time();
			self::$floodmessage[$target][$userObj->fullMask()]['count']++;
			return false;
	
			
			
		}
		
	}

?>